/**
 *
 */
package de.intevation.gnv.action;

import java.util.Collection;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import de.intevation.gnv.action.sessionmodel.SessionModel;
import de.intevation.gnv.action.sessionmodel.SessionModelFactory;
import de.intevation.gnv.artifactdatabase.client.ArtifactDatabaseClientFactory;
import de.intevation.gnv.artifactdatabase.objects.ArtifactObject;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public class FetchArtifactFactoriesAction extends ArtifactDatabaseActionBase{
    /**
     * the logger, used to log exceptions and additonaly information
     */
    private static Logger log = Logger.getLogger(FetchArtifactFactoriesAction.class);

    public FetchArtifactFactoriesAction() {
        super();
    }

    /**
     * @see de.intevation.gnv.action.ArtifactDatabaseActionBase#execute(org.apache.struts.action.ActionMapping, org.apache.struts.action.ActionForm, javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
     */
    @Override
    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception {
        log.debug("ArtifactDatabaseActionBase.execute");
        
        Collection<ArtifactObject> artifactFactories = ArtifactDatabaseClientFactory.getInstance().getArtifactDatabaseClient().getArtifactFactories();
        SessionModel sm = SessionModelFactory.getInstance().getSessionModel(request);
        sm.setArtifacteFactories(artifactFactories);
        
        
        ActionForward lForward = mapping.findForward(SUCCSESS_FORWARD_ID);
        return lForward;
    }
    
}
